﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Diagnostics;

namespace howto_increment_speed
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Perform the trials.
        private void btnGo_Click(object sender, EventArgs e)
        {
            long num_trials = long.Parse(txtNumTrials.Text);
            lblXPlus1.Text = "";
            lblXIncr.Text = "";
            lblPlusEquals1.Text = "";
            lblPlus3.Text = "";
            lblPlusEquals3.Text = "";
            Cursor = Cursors.WaitCursor;
            Refresh();

            long x;
            Stopwatch watch = new Stopwatch();

            // Trials using x = x + 1.
            x = 1;
            watch.Start();
            for (long i = 0; i < num_trials; i++)
            {
                x = x + 1;
            }
            watch.Stop();
            lblXPlus1.Text = watch.Elapsed.TotalSeconds.ToString("0.00") + " seconds";
            lblXPlus1.Refresh();

            // Trials using x++.
            x = 1;
            watch.Reset();
            watch.Start();
            for (long i = 0; i < num_trials; i++)
            {
                x++;
            }
            watch.Stop();
            lblXIncr.Text = watch.Elapsed.TotalSeconds.ToString("0.00") + " seconds";
            lblXIncr.Refresh();

            // Trials using x += 1.
            x = 1;
            watch.Reset();
            watch.Start();
            for (long i = 0; i < num_trials; i++)
            {
                x += 1;
            }
            watch.Stop();
            lblPlusEquals1.Text = watch.Elapsed.TotalSeconds.ToString("0.00") + " seconds";
            lblPlusEquals1.Refresh();

            // Trials using x = x + 3.
            x = 1;
            watch.Reset();
            watch.Start();
            for (long i = 0; i < num_trials; i++)
            {
                x = x + 3;
            }
            watch.Stop();
            lblPlus3.Text = watch.Elapsed.TotalSeconds.ToString("0.00") + " seconds";
            lblPlus3.Refresh();

            // Trials using x += 3.
            x = 1;
            watch.Reset();
            watch.Start();
            for (long i = 0; i < num_trials; i++)
            {
                x += 3;
            }
            watch.Stop();
            lblPlusEquals3.Text = watch.Elapsed.TotalSeconds.ToString("0.00") + " seconds";
            lblPlusEquals3.Refresh();

            Cursor = Cursors.Default;
        }
    }
}
